/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _AMD64_MXCSR_REGPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _AMD64_MXCSR_REGPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_AMD64_MXCSR_REG.class)
public class _AMD64_MXCSR_REGPointer extends StructurePointer {

	// NULL
	public static final _AMD64_MXCSR_REGPointer NULL = new _AMD64_MXCSR_REGPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _AMD64_MXCSR_REGPointer(long address) {
		super(address);
	}

	public static _AMD64_MXCSR_REGPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _AMD64_MXCSR_REGPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _AMD64_MXCSR_REGPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _AMD64_MXCSR_REGPointer(address);
	}

	public _AMD64_MXCSR_REGPointer add(long count) {
		return _AMD64_MXCSR_REGPointer.cast(address + (_AMD64_MXCSR_REG.SIZEOF * count));
	}

	public _AMD64_MXCSR_REGPointer add(Scalar count) {
		return add(count.longValue());
	}

	public _AMD64_MXCSR_REGPointer addOffset(long offset) {
		return _AMD64_MXCSR_REGPointer.cast(address + offset);
	}

	public _AMD64_MXCSR_REGPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _AMD64_MXCSR_REGPointer sub(long count) {
		return _AMD64_MXCSR_REGPointer.cast(address - (_AMD64_MXCSR_REG.SIZEOF * count));
	}

	public _AMD64_MXCSR_REGPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _AMD64_MXCSR_REGPointer subOffset(long offset) {
		return _AMD64_MXCSR_REGPointer.cast(address - offset);
	}

	public _AMD64_MXCSR_REGPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _AMD64_MXCSR_REGPointer untag(long mask) {
		return _AMD64_MXCSR_REGPointer.cast(address & ~mask);
	}

	public _AMD64_MXCSR_REGPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _AMD64_MXCSR_REG.SIZEOF;
	}

	// Implementation methods

	// U32:1 DAZ
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DAZOffset_", declaredType="U32:1")
	public UDATA DAZ() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._DAZ_s_, _AMD64_MXCSR_REG._DAZ_b_);
	}

	// U32:1 DE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DEOffset_", declaredType="U32:1")
	public UDATA DE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._DE_s_, _AMD64_MXCSR_REG._DE_b_);
	}

	// U32:1 DM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DMOffset_", declaredType="U32:1")
	public UDATA DM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._DM_s_, _AMD64_MXCSR_REG._DM_b_);
	}

	// U32:1 FZ
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_FZOffset_", declaredType="U32:1")
	public UDATA FZ() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._FZ_s_, _AMD64_MXCSR_REG._FZ_b_);
	}

	// U32:1 IE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IEOffset_", declaredType="U32:1")
	public UDATA IE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._IE_s_, _AMD64_MXCSR_REG._IE_b_);
	}

	// U32:1 IM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IMOffset_", declaredType="U32:1")
	public UDATA IM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._IM_s_, _AMD64_MXCSR_REG._IM_b_);
	}

	// U32:1 OE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_OEOffset_", declaredType="U32:1")
	public UDATA OE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._OE_s_, _AMD64_MXCSR_REG._OE_b_);
	}

	// U32:1 OM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_OMOffset_", declaredType="U32:1")
	public UDATA OM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._OM_s_, _AMD64_MXCSR_REG._OM_b_);
	}

	// U32:1 PE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_PEOffset_", declaredType="U32:1")
	public UDATA PE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._PE_s_, _AMD64_MXCSR_REG._PE_b_);
	}

	// U32:1 PM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_PMOffset_", declaredType="U32:1")
	public UDATA PM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._PM_s_, _AMD64_MXCSR_REG._PM_b_);
	}

	// U32:2 RC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_RCOffset_", declaredType="U32:2")
	public UDATA RC() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._RC_s_, _AMD64_MXCSR_REG._RC_b_);
	}

	// U32:1 UE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_UEOffset_", declaredType="U32:1")
	public UDATA UE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._UE_s_, _AMD64_MXCSR_REG._UE_b_);
	}

	// U32:1 UM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_UMOffset_", declaredType="U32:1")
	public UDATA UM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._UM_s_, _AMD64_MXCSR_REG._UM_b_);
	}

	// U32 Value
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ValueOffset_", declaredType="U32")
	public UDATA Value() throws CorruptDataException {
		return new U32(getIntAtOffset(_AMD64_MXCSR_REG._ValueOffset_));
	}

	// U32 Value
	public UDATAPointer ValueEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(_AMD64_MXCSR_REG._ValueOffset_));
	}

	// U32:1 ZE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ZEOffset_", declaredType="U32:1")
	public UDATA ZE() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._ZE_s_, _AMD64_MXCSR_REG._ZE_b_);
	}

	// U32:1 ZM
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ZMOffset_", declaredType="U32:1")
	public UDATA ZM() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._ZM_s_, _AMD64_MXCSR_REG._ZM_b_);
	}

	// U32:16 res
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_resOffset_", declaredType="U32:16")
	public UDATA res() throws CorruptDataException {
		return getU32Bitfield(_AMD64_MXCSR_REG._res_s_, _AMD64_MXCSR_REG._res_b_);
	}

}
