/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _ARM64_FPCR_REGPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _ARM64_FPCR_REGPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_ARM64_FPCR_REG.class)
public class _ARM64_FPCR_REGPointer extends StructurePointer {

	// NULL
	public static final _ARM64_FPCR_REGPointer NULL = new _ARM64_FPCR_REGPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _ARM64_FPCR_REGPointer(long address) {
		super(address);
	}

	public static _ARM64_FPCR_REGPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _ARM64_FPCR_REGPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _ARM64_FPCR_REGPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _ARM64_FPCR_REGPointer(address);
	}

	public _ARM64_FPCR_REGPointer add(long count) {
		return _ARM64_FPCR_REGPointer.cast(address + (_ARM64_FPCR_REG.SIZEOF * count));
	}

	public _ARM64_FPCR_REGPointer add(Scalar count) {
		return add(count.longValue());
	}

	public _ARM64_FPCR_REGPointer addOffset(long offset) {
		return _ARM64_FPCR_REGPointer.cast(address + offset);
	}

	public _ARM64_FPCR_REGPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _ARM64_FPCR_REGPointer sub(long count) {
		return _ARM64_FPCR_REGPointer.cast(address - (_ARM64_FPCR_REG.SIZEOF * count));
	}

	public _ARM64_FPCR_REGPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _ARM64_FPCR_REGPointer subOffset(long offset) {
		return _ARM64_FPCR_REGPointer.cast(address - offset);
	}

	public _ARM64_FPCR_REGPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _ARM64_FPCR_REGPointer untag(long mask) {
		return _ARM64_FPCR_REGPointer.cast(address & ~mask);
	}

	public _ARM64_FPCR_REGPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _ARM64_FPCR_REG.SIZEOF;
	}

	// Implementation methods

	// U32:1 AHP
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_AHPOffset_", declaredType="U32:1")
	public UDATA AHP() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._AHP_s_, _ARM64_FPCR_REG._AHP_b_);
	}

	// U32:1 DN
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DNOffset_", declaredType="U32:1")
	public UDATA DN() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._DN_s_, _ARM64_FPCR_REG._DN_b_);
	}

	// U32:1 DZE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DZEOffset_", declaredType="U32:1")
	public UDATA DZE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._DZE_s_, _ARM64_FPCR_REG._DZE_b_);
	}

	// U32:1 FZ
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_FZOffset_", declaredType="U32:1")
	public UDATA FZ() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._FZ_s_, _ARM64_FPCR_REG._FZ_b_);
	}

	// U32:1 FZ16
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_FZ16Offset_", declaredType="U32:1")
	public UDATA FZ16() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._FZ16_s_, _ARM64_FPCR_REG._FZ16_b_);
	}

	// U32:1 IDE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IDEOffset_", declaredType="U32:1")
	public UDATA IDE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._IDE_s_, _ARM64_FPCR_REG._IDE_b_);
	}

	// U32:1 IOE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IOEOffset_", declaredType="U32:1")
	public UDATA IOE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._IOE_s_, _ARM64_FPCR_REG._IOE_b_);
	}

	// U32:1 IXE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IXEOffset_", declaredType="U32:1")
	public UDATA IXE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._IXE_s_, _ARM64_FPCR_REG._IXE_b_);
	}

	// U32:3 Len
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_LenOffset_", declaredType="U32:3")
	public UDATA Len() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._Len_s_, _ARM64_FPCR_REG._Len_b_);
	}

	// U32:1 OFE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_OFEOffset_", declaredType="U32:1")
	public UDATA OFE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._OFE_s_, _ARM64_FPCR_REG._OFE_b_);
	}

	// U32:2 RMode
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_RModeOffset_", declaredType="U32:2")
	public UDATA RMode() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._RMode_s_, _ARM64_FPCR_REG._RMode_b_);
	}

	// U32:2 Stride
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_StrideOffset_", declaredType="U32:2")
	public UDATA Stride() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._Stride_s_, _ARM64_FPCR_REG._Stride_b_);
	}

	// U32:1 UFE
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_UFEOffset_", declaredType="U32:1")
	public UDATA UFE() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._UFE_s_, _ARM64_FPCR_REG._UFE_b_);
	}

	// U32 Value
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ValueOffset_", declaredType="U32")
	public UDATA Value() throws CorruptDataException {
		return new U32(getIntAtOffset(_ARM64_FPCR_REG._ValueOffset_));
	}

	// U32 Value
	public UDATAPointer ValueEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(_ARM64_FPCR_REG._ValueOffset_));
	}

	// U32:8 res0_1
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_res0_1Offset_", declaredType="U32:8")
	public UDATA res0_1() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._res0_1_s_, _ARM64_FPCR_REG._res0_1_b_);
	}

	// U32:2 res0_2
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_res0_2Offset_", declaredType="U32:2")
	public UDATA res0_2() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._res0_2_s_, _ARM64_FPCR_REG._res0_2_b_);
	}

	// U32:5 res0_3
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_res0_3Offset_", declaredType="U32:5")
	public UDATA res0_3() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPCR_REG._res0_3_s_, _ARM64_FPCR_REG._res0_3_b_);
	}

}
