/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */
package com.ibm.j9ddr.vm29.structure;

/**
 * Structure: _AMD64_MXCSR_REG
 *
 * This stub class represents a class that can return in memory offsets
 * to VM C and C++ structures.
 *
 * This particular implementation exists only to allow StructurePointer code to
 * compile at development time.  This is never loaded at run time.
 *
 * At runtime generated byte codes returning actual offset values from the core file
 * will be loaded by the StructureClassLoader.
 */
public final class _AMD64_MXCSR_REG {

	// VM Constants

	public static final long SIZEOF;

	// Offsets

	public static final int _DAZ_s_;
	public static final int _DAZ_b_;
	public static final int _DE_s_;
	public static final int _DE_b_;
	public static final int _DM_s_;
	public static final int _DM_b_;
	public static final int _FZ_s_;
	public static final int _FZ_b_;
	public static final int _IE_s_;
	public static final int _IE_b_;
	public static final int _IM_s_;
	public static final int _IM_b_;
	public static final int _OE_s_;
	public static final int _OE_b_;
	public static final int _OM_s_;
	public static final int _OM_b_;
	public static final int _PE_s_;
	public static final int _PE_b_;
	public static final int _PM_s_;
	public static final int _PM_b_;
	public static final int _RC_s_;
	public static final int _RC_b_;
	public static final int _UE_s_;
	public static final int _UE_b_;
	public static final int _UM_s_;
	public static final int _UM_b_;
	public static final int _ValueOffset_;
	public static final int _ZE_s_;
	public static final int _ZE_b_;
	public static final int _ZM_s_;
	public static final int _ZM_b_;
	public static final int _res_s_;
	public static final int _res_b_;

	// Static Initializer

	private static final boolean RUNTIME = false;

	static {
		if (!RUNTIME) {
			throw new IllegalArgumentException("This stub class should not be on your classpath");
		}

		SIZEOF = 0;
		_DAZ_s_ = 0;
		_DAZ_b_ = 0;
		_DE_s_ = 0;
		_DE_b_ = 0;
		_DM_s_ = 0;
		_DM_b_ = 0;
		_FZ_s_ = 0;
		_FZ_b_ = 0;
		_IE_s_ = 0;
		_IE_b_ = 0;
		_IM_s_ = 0;
		_IM_b_ = 0;
		_OE_s_ = 0;
		_OE_b_ = 0;
		_OM_s_ = 0;
		_OM_b_ = 0;
		_PE_s_ = 0;
		_PE_b_ = 0;
		_PM_s_ = 0;
		_PM_b_ = 0;
		_RC_s_ = 0;
		_RC_b_ = 0;
		_UE_s_ = 0;
		_UE_b_ = 0;
		_UM_s_ = 0;
		_UM_b_ = 0;
		_ValueOffset_ = 0;
		_ZE_s_ = 0;
		_ZE_b_ = 0;
		_ZM_s_ = 0;
		_ZM_b_ = 0;
		_res_s_ = 0;
		_res_b_ = 0;
	}

}
